Option Explicit On

Imports System.Threading

Public Class clsUserSelection

    Public AllowCancel As Boolean = False
    Public retIndex As Integer = -1

    Public Delegate Sub RequestUserSelectionFunc(ByVal objUserSelection As clsUserSelection, ByVal caption As String)

    Private _columns As New Collection
    Private _rows As New Collection
    Private _waitObj As New ManualResetEvent(False)

    Public Sub AddColumn(ByVal colText As String)

        _columns.Add(colText)

    End Sub

    Public Sub AddRow(ByVal ParamArray cellText() As String)

        _rows.Add(cellText)

    End Sub

    Public Function GetColumn(ByVal index As Integer) As String

        If index > 0 And index <= _columns.Count Then
            Return _columns(index)
        Else
            Return ""
        End If

    End Function

    Public Function GetColumnCount() As Integer
        Return _columns.Count
    End Function

    Public Function GetRow(ByVal index As Integer) As String()

        If index > 0 And index <= _rows.Count Then
            Return _rows(index)
        Else
            Return Array.CreateInstance(GetType(String), 0)
        End If

    End Function

    Public Function GetRowCount() As Integer
        Return _rows.Count
    End Function

    Public Sub Wait()

        ' tell the invoking thread to wait for user selection
        _waitObj.WaitOne()

    End Sub

    Public Sub [Resume]()

        ' tell the invoking thread to resume execution
        _waitObj.Set()

    End Sub

    Public Overloads Sub Show(ByVal showFunc As RequestUserSelectionFunc)

        ' invoke the request on the calling form
        showFunc.Invoke(Me, Nothing)

    End Sub

    Public Overloads Sub Show(ByVal showFunc As RequestUserSelectionFunc, _
        ByVal caption As String)

        ' invoke the request on the calling form
        showFunc.Invoke(Me, caption)

    End Sub

End Class
